;; Problem 28
;; 11 October 2002

;; Starting with the number 1 and moving to the right in a clockwise direction a 5 by 5 spiral is formed as follows:

;; 21 22 23 24 25
;; 20  7  8  9 10
;; 19  6  1  2 11
;; 18  5  4  3 12
;; 17 16 15 14 13

;; It can be verified that the sum of both diagonals is 101.

;; What is the sum of both diagonals in a 1001 by 1001 spiral formed in the same way?


;; up/right    1 9 25 49  8/16/24
;; down/right  1 3 13 31  2/10/18
;; down/left   1 5 17 37  4/12/20
;; up/left     1 7 21 43  6/14/22
;;
;; Each sequence has a 'base' starting with the pair of 1 a base, and
;; an increment, then we incf the increment by 8 creating a continuing
;; sum.  This basically measures the size of each connencentric
;; perimiter added to the spiral.




;; 43 44 45 46 47 48 49
;; 42 21 22 23 24 25 26
;; 41 20  7  8  9 10 27
;; 40 19  6  1  2 11 28
;; 39 18  5  4  3 12 29
;; 38 17 16 15 14 13 30
;; 37 36 35 34 33 32 31

;; the length of a diagonal (from the center to the corner of an NxN
;; is (N+1)/2:
;;
;;  1x1 = 1
;;  3x3 = 2 (3+1)/2=2
;;  5x5 = 3 6/2 = 3
;;  7x7 = 4
;; 1001x1001 = 501

(defun gen-up-right (count)
  (let ((numbers (list)))
    (loop for ii from 1 to count
	  for next = 1 then (+ next base)
	  for base = 8 then (+ base 8)
	  do
	  (push next numbers))
    (reverse numbers)))

;; (gen-up-right 5)

(defun gen-down-right (count)
  (let ((numbers (list)))
    (loop for ii from 1 to count
	  for next = 1 then (+ next base)
	  for base = 2 then (+ base 8)
	  do
	  (push next numbers))
    (reverse numbers)))

;; (gen-down-right 5)


(defun gen-down-left (count)
  (let ((numbers (list)))
    (loop for ii from 1 to count
	  for next = 1 then (+ next base)
	  for base = 4 then (+ base 8)
	  do
	  (push next numbers))
    (reverse numbers)))

;; (gen-down-left 5)


(defun gen-up-left (count)
  (let ((numbers (list)))
    (loop for ii from 1 to count
	  for next = 1 then (+ next base)
	  for base = 6 then (+ base 8)
	  do
	  (push next numbers))
    (reverse numbers)))

;; (gen-up-left 5)
;; 43

;; summing this way, we count the central '1' 4 times, which is 3
;; times too many, hence the -3
(+
 (apply #'+ (gen-up-right 3))
 (apply #'+ (gen-down-right 3))
 (apply #'+ (gen-down-left 3))
 (apply #'+ (gen-up-left 3))
 -3)

(princ
 (+
  (apply #'+ (gen-up-right 501))
  (apply #'+ (gen-down-right 501))
  (apply #'+ (gen-down-left 501))
  (apply #'+ (gen-up-left 501))
 -3))
